self.firstperson = false
self.dirspeed = true
minigame.setLives(5)

self.name = "Snake"
self.icon = "snake_icon.png"
self.author = "HugoBDesigner"

self.canflip = true
self.snakeMaxSize = 40
self.maxLevel = 8
function snake_load(level)
	print("LOAD")
	minigame.setProgress(0)
	self.head = {x = 4, y = 2, dirx = 0, diry = 0}
	
	self.snake = {}
	for i = 2, 1, -1 do
		table.insert(self.snake, {self.head.x-i, self.head.y})
	end
	
	
	self.settings = {
		{"Flip snake", "canflip", "toggle"},
		{"Snake maximum size", "snakeMaxSize", "number", {30, 60}},
		{"First person mode", "firstperson", "toggle"},
		{"Directional speeding", "dirspeed", "toggle"}
	}
	
	self.blocks = {}
	self.nonfood = {}
	self.loadBlocks(level)
	self.food = self.randomFood()
	self.foodcolor = 1
	self.foodcolors = {.6, .2}
	self.foodtimer = 0
	self.foodmaxtimer = .25
	self.foodmaxtimer2 = .05
	
	self.snakeTime = 0
	self.snakeTimer = .4
	self.snakeFastTimer = .1
	self.fast = false
	self.fasttime = false
	self.flipside = false
	
	self.dead = false
	self.deathTime = 1
	self.levelup = false
	self.levelupTime = 0
	self.levelupTimer = 2
	
	self.gameover = {false, 4}
	
	self.eating = false
end

function snake_update(dt)
	local speed = minigame.getSpeed()
	if self.gameover[1] then
		self.gameover[1] = self.gameover[1] + dt
		if self.gameover[1] >= self.gameover[2] then
			self.gameover[1] = false
			minigame.gameOver()
		end
		return
	end
	
	if minigame.lastButton("up") and self.flipside ~= "up" then
		self.flipside = false
		local y = self.head.y-1
		if y < 1 then y = y+32 end
		if self.snake[#self.snake][1] == self.head.x and self.snake[#self.snake][2] == y then
			self.fast = false
		else
			self.head.dirx = 0
			self.head.diry = -1
		end
	elseif minigame.lastButton("down") and self.flipside ~= "down" then
		self.flipside = false
		local y = self.head.y+1
		if y > 32 then y = y-32 end
		if self.snake[#self.snake][1] == self.head.x and self.snake[#self.snake][2] == y then
			self.fast = false
		else
			self.head.dirx = 0
			self.head.diry = 1
		end
	elseif minigame.lastButton("left") and self.flipside ~= "left" then
		self.flipside = false
		local x = self.head.x-1
		if x < 1 then x = x+32 end
		if self.snake[#self.snake][1] == x and self.snake[#self.snake][2] == self.head.y then
			self.fast = false
		else
			self.head.dirx = -1
			self.head.diry = 0
		end
	elseif minigame.lastButton("right") and self.flipside ~= "right" then
		self.flipside = false
		local x = self.head.x+1
		if x > 32 then x = x-32 end
		if self.snake[#self.snake][1] == x and self.snake[#self.snake][2] == self.head.y then
			self.fast = false
		else
			self.head.dirx = 1
			self.head.diry = 0
		end
	end
	
	if minigame.buttonDown("big") then
		self.fast = true
		self.fasttime = 0
	end
	
	if (self.head.dirx ~= 0 or self.head.diry ~= 0) and not self.levelup and not self.dead then
		self.snakeTime = self.snakeTime + dt*speed
		if (not self.fast and self.snakeTime >= self.snakeTimer) or (self.fast and self.snakeTime >= self.snakeFastTimer) then
			local newx, newy = self.head.x + self.head.dirx, self.head.y + self.head.diry
			if newx < 1 then newx = newx+32 end
			if newy < 1 then newy = newy+32 end
			if newx > 32 then newx = newx-32 end
			if newy > 32 then newy = newy-32 end
			
			if table.contains(self.snake, {newx, newy}) then
				if newx ~= self.snake[1][1] or newy ~= self.snake[1][2] then
					self.dead = true
				else
					self.updateSnake()
				end
			elseif table.contains(self.blocks, {newx, newy}) then
				self.dead = true
			else
				self.updateSnake()
			end
			self.snakeTime = 0
		end
	end
	
	if (minigame.buttonDown("up") or minigame.buttonDown("down") or minigame.buttonDown("left") or minigame.buttonDown("right")) and self.dirspeed then
		if self.fasttime == false or self.fasttime < 0 then
			--FAST HOLDING TIMER
			self.fasttime = .2
		end
		self.fasttime = math.max(0, self.fasttime - dt)
		
		if self.fasttime == 0 then
			self.fast = true
		end
	elseif minigame.buttonDown("big") == false then
		--Cooldown between button presses. Let's not punish the player for not mashing buttons fast enough,
		--while also ensuring the cooldown is so long that the player dies instantly
		if self.fasttime then
			self.fasttime = self.fasttime - dt
			--FAST COOLDOWN TIMER
			if self.fasttime <= 0 then
				self.fasttime = false
				self.fast = false
			end
		end
	end
	
	if self.dead then
		self.deathTime = self.deathTime - dt
		if self.deathTime <= 0 then
			if minigame.getLives() == 0 then
				snake_gameOver()
			else
				minigame.removeLives(1)
				minigame.resetLevel()
			end
		end
	elseif self.levelup then
		self.levelupTime = self.levelupTime + dt
		if self.levelupTime >= self.levelupTimer then
			minigame.addLives(1)
			minigame.levelUp()
		end
	end
	
	self.foodtimer = self.foodtimer + dt
	if self.foodtimer >= self.foodmaxtimer+self.foodmaxtimer2 then
		self.foodcolor = 1
		self.foodtimer = 0
	elseif self.foodtimer > self.foodmaxtimer then
		self.foodcolor = 2
	end
end

function snake_draw()
	local forlimit = 1
	if self.firstperson then
		forlimit = 3
	end
	for gamex = 1, forlimit do
		for gamey = 1, forlimit do
			local translatex, translatey = -self.head.x+16, -self.head.y+16
			if gamex < math.ceil(forlimit/2) then
				translatex = translatex - (math.ceil(forlimit/2)-gamex)*32
			end
			if gamey < math.ceil(forlimit/2) then
				translatey = translatey - (math.ceil(forlimit/2)-gamey)*32
			end
			if gamex > math.ceil(forlimit/2) then
				translatex = translatex + (gamex-math.ceil(forlimit/2))*32
			end
			if gamey > math.ceil(forlimit/2) then
				translatey = translatey + (gamey-math.ceil(forlimit/2))*32
			end
			
			if self.firstperson then
				minigame.translate(translatex, translatey)
			end
			
			minigame.setColor(.8)
			for i, v in pairs(self.snake) do
				minigame.point(v[1], v[2])
			end
			minigame.setColor(1)
			for i, v in pairs(self.blocks) do
				minigame.point(v[1], v[2])
			end
			minigame.point(self.head.x, self.head.y)
			
			minigame.setColor(self.foodcolors[self.foodcolor])
			minigame.point(self.food[1], self.food[2])
			
			minigame.setColor(1)
			minigame.pixelMode("replace")
			if self.dead then
				local frames = 4
				local repeats = 4
				
				local f = math.ceil((frames*repeats)*self.deathTime)
				f = f-math.floor(f/repeats)*frames
				if f == 0 then f = frames end
				
				if self.firstperson then
					minigame.draw(self.images[f], self.head.x-pixels+pixels*(gamex-1)-3, self.head.y-pixels+pixels*(gamey-1)-3)
				else
					minigame.draw(self.images[f], self.head.x-3, self.head.y-3)
				end
			end
			minigame.pixelMode("blend")
			
			if self.foodcolor == false then
				minigame.setColor(.2)
				for i, v in pairs(self.flash) do
					minigame.point(v[1], v[2])
				end
			end
		end
	end
	minigame.translate()
	if self.levelup then
		local s = self.levelupTime
		if self.levelupTime >= self.levelupTimer/2 then
			s = self.levelupTimer-s
		end
		s = s/(self.levelupTimer/2)
		s = math.ceil(s*32)
		minigame.setColor(1)
		minigame.rectangle("fill", 1, 32-s+1, 32, s)
		if self.levelupTime >= self.levelupTimer/2 then
			minigame.setColor(0)
			minigame.pixelMode("replace")
			minigame.rectangle("fill", 1, 1, 32, 32-s)
			minigame.pixelMode("blend")
		end
	end
	
	if minigame.isPaused() then
		minigame.setColor(.6)
		minigame.rectangle("line", 1, 1, 32, 32)
		minigame.setColor(.4)
		minigame.rectangle("line", 2, 2, 30, 30)
		minigame.setColor(.2)
		minigame.rectangle("line", 3, 3, 28, 28)
	end
	
	if self.gameover[1] then
		local f = self.gameover[1]/(self.gameover[2]/2)
		if self.gameover[1] > self.gameover[2]/2 then
			f = 1 - (self.gameover[1]-self.gameover[2]/2)/(self.gameover[2]/2)
			minigame.pixelMode("r")
			minigame.setColor(0)
			minigame.rectangle("fill", 1, 1, 32, 32)
			minigame.pixelMode("b")
		end
		minigame.setColor(1)
		local h = math.ceil(32*f)
		minigame.rectangle("fill", 1, 32-h+1, 32, 32)
	end
end

function snake_buttonPressed(button)
	if self.dead or self.levelup then return end
	
	if button == "big" and minigame.buttonDown("pause") then
		minigame.levelUp()
	end
	
	if button == "up" then
		local y = self.head.y-1
		if y < 1 then y = y+32 end
		if self.snake[#self.snake][1] == self.head.x and self.snake[#self.snake][2] == y then
			self.flipSnake()
			self.flipside = "up"
			if self.diry == -1 then
				self.flipside = false
			end
		end
	elseif button == "down" then
		local y = self.head.y+1
		if y > 32 then y = y-32 end
		if self.snake[#self.snake][1] == self.head.x and self.snake[#self.snake][2] == y then
			self.flipSnake()
			self.flipside = "down"
			if self.diry == 1 then
				self.flipside = false
			end
		end
	elseif button == "left" then
		local x = self.head.x-1
		if x < 1 then x = x+32 end
		if self.snake[#self.snake][1] == x and self.snake[#self.snake][2] == self.head.y then
			self.flipSnake()
			self.flipside = "left"
			if self.dirx == -1 then
				self.flipside = false
			end
		end
	elseif button == "right" then
		local x = self.head.x+1
		if x > 32 then x = x-32 end
		if self.snake[#self.snake][1] == x and self.snake[#self.snake][2] == self.head.y then
			self.flipSnake()
			self.flipside = "right"
			if self.dirx == 1 then
				self.flipside = false
			end
		end
	end
end

function snake_buttonReleased(button)
	if self.flipside == button then
		self.flipside = false
	end
end

function snake_gameOver()
	self.gameover[1] = 0
end

function self.updateSnake()
	table.insert(self.snake, {self.head.x, self.head.y})
	if not self.eating then
		table.remove(self.snake, 1)
	end
	self.eating = false
	
	self.head.x = self.head.x + self.head.dirx
	self.head.y = self.head.y + self.head.diry
	
	if self.head.x < 1 then self.head.x = self.head.x+32 end
	if self.head.y < 1 then self.head.y = self.head.y+32 end
	if self.head.x > 32 then self.head.x = self.head.x-32 end
	if self.head.y > 32 then self.head.y = self.head.y-32 end
	
	if self.head.x == self.food[1] and self.head.y == self.food[2] then
		self.eating = true
		self.food = self.randomFood()
		minigame.addScore(100)
		if #self.snake >= self.snakeMaxSize-2 then --minus two because we consider the head AND the ate one
			self.levelup = true
			minigame.addScore(1000)
		end
	end
	
	minigame.setProgress((#self.snake-2) / (self.snakeMaxSize-3))
end

function self.randomFood()
	local t = {}
	for x = 1, 32 do
		for y = 1, 32 do
			if x == self.head.x and y == self.head.y then
				--ignore
			elseif table.contains(self.snake, {x, y}) then
				--ignore as well
			elseif table.contains(self.blocks, {x, y}) then
				--can't eat walls
			elseif table.contains(self.nonfood, {x, y}) then
				--never allowed
			else
				table.insert(t, {x, y})
			end
		end
	end
	return t[math.random(#t)]
end

function self.flipSnake()
	if not self.canflip then return end
	local newsnake = {}
	for i = #self.snake, 1, -1 do
		table.insert(newsnake, self.snake[i])
	end
	table.insert(newsnake, 1, {self.head.x, self.head.y})
	self.head.x = newsnake[#newsnake][1]
	self.head.y = newsnake[#newsnake][2]
	table.remove(newsnake)
	self.head.dirx = self.head.x-newsnake[#newsnake][1]
	self.head.diry = self.head.y-newsnake[#newsnake][2]
	
	self.snake = newsnake
end

function self.loadBlocks(level)
	--print("level = " ..tostring(level))
	if type(level) == "table" then
		for i, v in pairs(level) do
			--print("level["..i.."] = " .. tostring(v))
		end
	end
	local blocks = {}
	local player = {}
	local head = {x = 4, y = 2}
	
	--This WILL throw an error if level does not exist. But that's the minigame's way of knowing there are no more levels
	local map = love.image.newImageData("games/SnakeLevels/" .. level .. ".png")
	
	if map then
		for x = 1, map:getWidth() do
			for y = 1, map:getHeight() do
				if x <= 32 and y <= 32 then
					local r, g, b, a = map:getPixel(x-1, y-1)
					if r == 0 and g == 0 and b == 0 and a ~= 0 then
						table.insert(blocks, {x, y})
					elseif r == 1 and g == 0 and b == 0 and a ~= 0 then
						head = {x = x, y = y}
					elseif r == 1 and g ~= 0 and b == 0 and a ~= 0 then
						table.insert(player, {x, y})
					elseif r == 0 and g == 0 and b == 1 and a ~= 0 then
						table.insert(self.nonfood, {x, y})
					end
				end
			end
		end
	end
	
	local body = {}
	local center = {head.x, head.y}
	for i = 1, #player do
		local top = table.contains(player, {center[1], center[2]-1})
		local left = table.contains(player, {center[1]-1, center[2]})
		local right = table.contains(player, {center[1]+1, center[2]})
		local bottom = table.contains(player, {center[1], center[2]+1})
		
		if top then
			table.insert(body, {center[1], center[2]-1})
			center = {body[#body][1], body[#body][2]}
			player[top] = false
		elseif left then
			table.insert(body, {center[1]-1, center[2]})
			center = {body[#body][1], body[#body][2]}
			player[left] = false
		elseif right then
			table.insert(body, {center[1]+1, center[2]})
			center = {body[#body][1], body[#body][2]}
			player[right] = false
		elseif bottom then
			table.insert(body, {center[1], center[2]+1})
			center = {body[#body][1], body[#body][2]}
			player[bottom] = false
		end
	end
	self.blocks = blocks
	self.head.x = head.x
	self.head.y = head.y
	self.snake = {}
	for i = #body, 1, -1 do
		table.insert(self.snake, body[i])
	end
end

local ff = false
self.images = {
	{	{ff, ff, ff, ff, ff, ff, ff},
		{ff, ff, ff, ff, ff, ff, ff},
		{ff, ff, .2, .2, .2, ff, ff},
		{ff, ff, .2, .6, .2, ff, ff},
		{ff, ff, .2, .2, .2, ff, ff},
		{ff, ff, ff, ff, ff, ff, ff},
		{ff, ff, ff, ff, ff, ff, ff}},
	
	{	{ff, ff, ff, ff, ff, ff, ff},
		{ff, ff, .2, .6, .2, ff, ff},
		{ff, .2, .6, .8, .6, .2, ff},
		{ff, .6, .8, .8, .8, .6, ff},
		{ff, .2, .6, .8, .6, .2, ff},
		{ff, ff, .2, .6, .2, ff, ff},
		{ff, ff, ff, ff, ff, ff, ff}},
	
	{	{ 1, .6, .2, ff, .2, .6,  1},
		{.6,  1, .6,  1, .6,  1, .6},
		{.2, .6, .8,  1, .8, .6, .2},
		{ff,  1,  1,  1,  1,  1, ff},
		{.2, .6, .8,  1, .8, .6, .2},
		{.6,  1, .6,  1, .6,  1, .6},
		{ 1, .6, .2, ff, .2, .6,  1}},
	
	{	{ff, .2, ff, ff, ff, .2, ff},
		{.2,  1, .2, .6, .2,  1, .2},
		{ff, .2, .6,  1, .6, .2, ff},
		{ff, .6,  1,  1,  1, .6, ff},
		{ff, .2, .6,  1, .6, .2, ff},
		{.2,  1, .2, .6, .2,  1, .2},
		{ff, .2, ff, ff, ff, .2, ff}},
}
