settings = {}
local self = settings
function settings_load(menusel)
	minigame.saveSettings()
	buttonsDown = {}
	self.colordown = false
	self.colortimer = 0
	self.colormaxtime = .25
	self.repeattimer = 0
	self.repeatmaxtimer = {.025, .075}
	self.laststate = state
	state = "settings"
	self.menusel = menusel or 1
	
	if self.laststate == "game" then
		gamepaused = true
	end
	
	self.selected = 1
	
	self.options = {
		"R: ",
		"G: ",
		"B: ",
		"Skin:",
		"Return to menu"
	}
	
	self.quitmode = false
	minigame.loadSettings()
	
	self.gameoptions = false
	if currentgame then
		if self.laststate ~= "game" then
			state = "settings"
			minigame.loadGame()
			minigame.loadGameSettings()
			if _G[currentgame .. "_load"] then
				_G[currentgame .. "_load"](1)
			end
		end
		if _G[currentgame .. "_data"].settings then
			self.gameoptions = _G[currentgame .. "_data"].settings
		end
	end
	self.gameoptionssize = 0
	if self.gameoptions then
		self.gameoptionssize = #self.gameoptions
	end
	
	self.selectorx = 4
	self.x = 9
	self.tab = 4
	
	self.translatelast = 0
	self.translatenext = 0
	self.translatesteps = 3
	self.translatey = 0
end

function settings_update(dt)
	if self.colordown then
		if self.colortimer < self.colormaxtime then
			self.colortimer = self.colortimer + dt
		else
			if self.repeattimer == 0 then
				if self.selected <= 3 then
					minigame.skincolor[self.selected] = math.min(math.max(0, minigame.skincolor[self.selected]+self.colordown), 255)
				elseif self.selected > 5 then
					if self.gameoptions[self.selected-5][3] == "number" then
						local option = self.gameoptions[self.selected-5]
						local add = 1
						if option[4][3] then
							add = option[4][3]
						end
						add = add*self.colordown
						local var = _G[currentgame .. "_data"][option[2]]
						_G[currentgame .. "_data"][option[2]] = math.min(math.max(option[4][1], var+add), option[4][2])
					end
				end
			end
			self.repeattimer = self.repeattimer + dt
			if self.selected <= 3 and self.repeattimer >= self.repeatmaxtimer[1] then
				self.repeattimer = 0
			elseif self.selected >= 5 and self.repeattimer >= self.repeatmaxtimer[2] then
				self.repeattimer = 0
			end
		end
	end
	
	if self.translatey ~= self.translatenext then
		self.translatey = self.translatey + (self.translatenext-self.translatelast)/self.translatesteps
		
		if self.translatenext < self.translatelast then
			self.translatey = math.min(self.translatelast, self.translatey)
			self.translatey = math.max(self.translatenext, self.translatey)
		else
			self.translatey = math.min(self.translatenext, self.translatey)
			self.translatey = math.max(self.translatelast, self.translatey)
		end
	end
end

function settings_draw()
	love.graphics.translate(0, -self.translatey)
	
	minigame.setColor(.2)
	minigame.rectangle("fill", self.x+self.tab, 4+(11)*2, 165, 10)
	minigame.rectangle("fill", self.x+self.tab, 4+(11)*4, 165, 10)
	minigame.rectangle("fill", self.x+self.tab, 4+(11)*6, 165, 10)
	
	minigame.setColor(1)
	minigame.print("Minigame colors:", self.x, 5)
	minigame.print(self.options[1] .. minigame.skincolor[1], self.x+self.tab, 5+(11)*1)
	minigame.rectangle("fill", self.x+self.tab, 4+(11)*2, minigame.skincolor[1]/255*165, 10)
	
	minigame.print(self.options[2] .. minigame.skincolor[2], self.x+self.tab, 5+(11)*3)
	minigame.rectangle("fill", self.x+self.tab, 4+(11)*4, minigame.skincolor[2]/255*165, 10)
	
	minigame.print(self.options[3] .. minigame.skincolor[3], self.x+self.tab, 5+(11)*5)
	minigame.rectangle("fill", self.x+self.tab, 4+(11)*6, minigame.skincolor[3]/255*165, 10)
	
	minigame.print(self.options[4], self.x, 5+(11)*7)
	minigame.print(minigame.set, self.x+self.tab, 5+(11)*8)
	
	minigame.print(self.options[5], self.x, 5+(11)*9)
	
	minigame.setColor(.4)
	local s = "Are you sure? "
	if self.quitmode == "Yes" then
		local x = self.x+self.tab+minigame.printSize(s)
		minigame.print("[Yes]", x+1, 5+(11)*10)
	end
	s = s .. (self.quitmode == "Yes" and "[" or "") .. "Yes" .. (self.quitmode == "Yes" and "]" or "")
	s = s .. "  "
	if self.quitmode == "No" then
		local x = self.x+self.tab+minigame.printSize(s)
		minigame.print("[No]", x+1, 5+(11)*10)
	end
	s = s .. (self.quitmode == "No" and "[" or "") .. "No" .. (self.quitmode == "No" and "]" or "")
	
	minigame.setColor(1)
	if self.quitmode == false then
		minigame.setColor(.4)
	end
	minigame.print(s, self.x+self.tab, 5+(11)*10)
	
	minigame.setColor(1)
	if self.selected < 6 then
		minigame.circle("fill", self.selectorx, 8+(11)*self.selected*2, 3, 8)
	else
		minigame.circle("fill", self.selectorx, 82+(11)*self.selected, 3, 8)
	end
	
	if self.gameoptions then
		minigame.print("Game Options:", self.x, 24+(11)*10)
		for i, v in pairs(self.gameoptions) do
			local txt = v[1] .. ": "
			local var = _G[currentgame .. "_data"][v[2]]
			
			if v[3] == "toggle" then
				if var then txt = txt .. "ON"
				else txt = txt .. "OFF" end
			elseif v[3] == "number" then
				if var > v[4][1] then
					txt = txt .. "< "
				end
				txt = txt .. tostring(var)
				if var < v[4][2] then
					txt = txt .. " >"
				end
			elseif v[3] == "swap" then
				txt = txt .. "< " .. tostring(var) .. " >"
			end
			
			minigame.print(txt, self.x+self.tab, 24+(11)*10+i*11)
		end
	end
end

function settings_buttonPressed(button)
	if button == "down" then
		self.selected = self.selected + 1
		if self.selected > #self.options+self.gameoptionssize then
			self.selected = 1
		end
		if self.selected >= 11 then
			self.translatelast = self.translatey
			self.translatenext = 11+(self.selected-11)*11
		else
			self.translatelast = self.translatey
			self.translatenext = 0
		end
		self.quitmode = false
		if self.selected == 5 then
			self.quitmode = "No"
		end
	elseif button == "up" then
		self.selected = self.selected - 1
		if self.selected < 1 then
			self.selected = #self.options+self.gameoptionssize
		end
		if self.selected >= 11 then
			self.translatelast = self.translatey
			self.translatenext = 11+(self.selected-11)*11
		else
			self.translatelast = self.translatey
			self.translatenext = 0
		end
		self.quitmode = false
		if self.selected == 5 then
			self.quitmode = "No"
		end
	elseif button == "left" then
		if self.selected >= 1 and self.selected <= 3 then
			self.colordown = -1
			minigame.skincolor[self.selected] = math.max(0, minigame.skincolor[self.selected]-1)
		elseif self.selected == 4 then
			local currentskin = table.contains(minigame.skins, minigame.set)
			if currentskin then
				currentskin = currentskin - 1
				if currentskin < 1 then
					currentskin = #minigame.skins
				end
				loadSet(minigame.skins[currentskin])
			else
				currentskin = table.contains(minigame.skins, "default")
			end
			loadSet(minigame.skins[currentskin])
		elseif self.selected == 5 then
			if self.quitmode == "No" then
				self.quitmode = "Yes"
			else
				self.quitmode = "No"
			end
		else
			local option = self.gameoptions[self.selected-5]
			local var = _G[currentgame .. "_data"][option[2]]
			if option[3] == "toggle" then
				_G[currentgame .. "_data"][option[2]] = not var
			elseif option[3] == "swap" then
				local sel = table.contains(option[4], var)
				if sel then
					if sel - 1 < 1 then
						sel = #option[4]
					else
						sel = sel - 1
					end
				end
				_G[currentgame .. "_data"][option[2]] = option[4][sel]
			elseif option[3] == "number" then
				self.colordown = -1
				local add = 1
				if option[4][3] then
					add = option[4][3]
				end
				local var = _G[currentgame .. "_data"][option[2]]
				var = math.max(option[4][1], var-add)
				_G[currentgame .. "_data"][option[2]] = var
			end
		end
	elseif button == "right" then
		if self.selected == 1 or self.selected == 2 or self.selected == 3 then
			self.colordown = 1
			minigame.skincolor[self.selected] = math.min(255, minigame.skincolor[self.selected]+1)
		elseif self.selected == 4 then
			local currentskin = table.contains(minigame.skins, minigame.set)
			if currentskin then
				currentskin = currentskin + 1
				if currentskin > #minigame.skins then
					currentskin = 1
				end
			else
				currentskin = table.contains(minigame.skins, "default")
			end
			loadSet(minigame.skins[currentskin])
		elseif self.selected == 5 then
			if self.quitmode == "No" then
				self.quitmode = "Yes"
			else
				self.quitmode = "No"
			end
		else
			local option = self.gameoptions[self.selected-5]
			local var = _G[currentgame .. "_data"][option[2]]
			if option[3] == "toggle" then
				_G[currentgame .. "_data"][option[2]] = not var
			elseif option[3] == "swap" then
				local sel = table.contains(option[4], var)
				if sel then
					if sel + 1 > #option[4] then
						sel = 1
					else
						sel = sel + 1
					end
				end
				_G[currentgame .. "_data"][option[2]] = option[4][sel]
			elseif option[3] == "number" then
				self.colordown = 1
				local add = 1
				if option[4][3] then
					add = option[4][3]
				end
				local var = _G[currentgame .. "_data"][option[2]]
				var = math.min(option[4][2], var+add)
				_G[currentgame .. "_data"][option[2]] = var
			end
		end
	elseif button == "big" then
		if self.selected >= 6 then
			local option = self.gameoptions[self.selected-5]
			local var = _G[currentgame .. "_data"][option[2]]
			if option[3] == "toggle" then
				_G[currentgame .. "_data"][option[2]] = not var
			end
		elseif self.selected == 5 then
			if self.quitmode == "Yes" then
				self.laststate = "menu"
				settings_quit()
			elseif self.laststate ~= "menu" then
				settings_quit()
			end
		end
	elseif button == "settings" or button == "pause" then
		settings_quit()
	end
end

function settings_buttonReleased(button)
	if button == "left" then
		self.colordown = false
		self.repeattimer = 0
		self.colortimer = 0
	elseif button == "right" then
		self.colordown = false
		self.repeattimer = 0
		self.colortimer = 0
	end
end

function settings_quit()
	buttonsDown = {}
	for i, v in pairs(minigame.buttons) do
		v.down = false
	end
	minigame.saveSettings()
	minigame.saveGameSettings()
	state = self.laststate
	if state == "menu" then
		gamescore = 0
		gamepaused = false
		menut.selection = self.menusel
		menut.update()
	elseif state ~= "game" then
		_G[state .. "_load"]()
	end
end
